<template>
    <section id="body">
        <div class="box">
            <header>
                <h1 id="gameOver">GAME OVER</h1>
            </header>
            <p>The results are in!</p>
            <div id="score">{{playerName}}'s Score: {{score}}</div>
        </div>
        <div class="box">
            <QuizResults v-bind:questions="questions" v-bind:answers="answers"/>
        </div>
        <div class="box">
            <button class="btn btn-success button" v-on:click="clickPlayAgainButton">Play Again</button>
            <button class="btn btn-danger button" v-on:click="clickQuitButton">Quit</button>
        </div>
    </section>
</template>

<script>
    import QuizResults from "./QuizResults";

    export default {
        name: "GameOver",
        components: {
            QuizResults
        },
        data: function () {
            return {
                playerName: this.$route.params.name,
                answers: this.$route.params.answers,
                questions: this.$route.params.questions,
                score: 0
            };
        },
        created() {
            this.score = this.getScore(this.answers, this.questions);
        },
        methods: {
            clickPlayAgainButton: function () {
                this.$router.push({name: 'play', params: {name: this.playerName}});
            },
            clickQuitButton: function () {
                this.$router.push({path: '/'});
            },
            getScore: function (a, q) {
                if (!a) {
                    return 0;
                }
                let score = 0;
                for (let i = 0; i < a.length; i++) {
                    if (a[i] === q[i].correct_answer) {
                        score += 10;
                    }
                }
                return score;
            }
        }
    }
</script>

<style scoped>
    #body {
        margin-bottom: 500px;
    }

    .box {
        background-color: linen;
        display: table;
        margin: auto auto 30px auto;
        border: 10px solid #DFDFDF;
        width: 700px;
        border-radius: 10px;
    }

    #gameOver {
        color: #FFF;
        background-color: #FF0000;
        font-weight: bold;
    }

    #score {
        font-size: 30px;
        font-weight: bold;
    }

    .button {
        font-size: 30px;
        padding: 10px;
        width: 300px;
        margin: 20px;
    }
</style>